package jws.awt.net;

// Copyright 1997, John Webster Small
// All rights Reserved

import jws.awt.*;
import java.awt.*;
import java.awt.event.*;

public class SMTPPOP3Config
{
  private SMTPwConfig smtp;
  private POP3wConfig pop3;

  public SMTPPOP3Config(SMTPwConfig smtp, POP3wConfig pop3)
  {
    this.smtp = smtp;
    this.pop3 = pop3;
  }

  public boolean configure(Frame parent, String title)
  {
    final WinDialog wd =
      new WinDialog(parent,title,true);
    wd.add("North",smtp.configurePanel());
    wd.add("Center",pop3.configurePanel());
    Panel p = new Panel();
    Button applyButton = new Button("Apply");
    p.add(applyButton);
    Button cancelButton = new Button("Cancel");
    p.add(cancelButton);
    wd.add("South",p);
    wd.pack();
    applyButton.addActionListener
      (
        new ActionListener()
        {
          public void actionPerformed(ActionEvent e)
            { wd.apply(); wd.dispose(true); }
        }
      );
    cancelButton.addActionListener
      (
        new ActionListener()
        {
          public void actionPerformed(ActionEvent e)
            { wd.dispose(); }
        }
      );
    wd.setVisible(true);
    return wd.ok;
  }
}
